var ControlFacadeMixin, PropTypes, React, div, input, merge, span, _ref;

React = require('react');

merge = require('react/lib/merge');

PropTypes = React.PropTypes;

_ref = React.DOM, div = _ref.div, span = _ref.span, input = _ref.input;

ControlFacadeMixin = {
  propTypes: {
    control: PropTypes.func,
    controlProps: PropTypes.object,
    wrapper: PropTypes.func,
    facade: PropTypes.func
  },
  getDefaultProps: function() {
    return {
      wrapper: span
    };
  },
  getInitialState: function() {
    return {};
  },
  _render: function() {
    var wrapperProps, _ref1, _ref2, _ref3, _ref4, _ref5, _ref6;
    wrapperProps = merge(this._getWrapperProps(), {
      style: merge(this.props.style, {
        display: 'inline-block',
        position: 'relative'
      })
    });
    return this.props.wrapper(wrapperProps, this.props.facade({
      checked: (_ref1 = (_ref2 = this.props.checked) != null ? _ref2 : this.state.checked) != null ? _ref1 : this.props.defaultChecked,
      selected: (_ref3 = (_ref4 = this.props.selected) != null ? _ref4 : this.state.selected) != null ? _ref3 : this.props.defaultSelected,
      value: (_ref5 = (_ref6 = this.props.value) != null ? _ref6 : this.state.value) != null ? _ref5 : this.props.defaultValue
    }), this.props.control(this._getControlProps(), this.props.children));
  },
  _getWrapperProps: function() {
    var props;
    props = merge(this.props);
    delete props.controlProps;
    delete props.checked;
    delete props.defaultChecked;
    delete props.selected;
    delete props.defaultSelected;
    delete props.value;
    delete props.defaultValue;
    return props;
  },
  _getControlProps: function() {
    var props;
    props = merge(this.props.controlProps, {
      checked: this.props.checked,
      defaultChecked: this.props.defaultChecked,
      selected: this.props.selected,
      defaultSelected: this.props.defaultSelected,
      value: this.props.value,
      defaultValue: this.props.defaultValue
    });
    props.style = merge(props.style, {
      display: 'block',
      position: 'absolute',
      opacity: '0',
      top: 0,
      left: 0,
      width: '100%',
      height: '100%',
      border: '1px solid #000'
    });
    return this.getControlProps(props);
  }
};

module.exports = ControlFacadeMixin;
